<div class="loading-shade" *ngIf="dataSource.loading$ | async">
  <mat-progress-bar *ngIf="dataSource.loading$ | async" mode="indeterminate"></mat-progress-bar>
</div>
<div class="card-container">
  <mat-card>
    <div class="search-models">
      <mat-form-field class="full-width">
        <input matInput placeholder="Search" [(ngModel)]="search" (keyup.enter)="setFilter()">
        <button mat-button matSuffix (click)="setFilter()">
          <mat-icon>search</mat-icon>
        </button>
      </mat-form-field>
    </div>
    <mat-card-header>
      <mat-card-title>{{ snakeToTitleCase(model) }}</mat-card-title>
    </mat-card-header>
    <mat-card-content class="table-container">
      <table mat-table class="full-width-table" [dataSource]="dataSource" matSort aria-label="Elements">
        <!-- Name Column -->
        <ng-container matColumnDef="name">
          <th mat-header-cell *matHeaderCellDef mat-sort-header (click)="setFilter()">Name</th>
          <td mat-cell *matCellDef="let row">
            <a [routerLink]="['/form/' + model, row.uuid]">{{row.name ? row.name : row.uuid}}</a>
          </td>
        </ng-container>

        <!-- UUID Column -->
        <ng-container matColumnDef="uuid">
          <th mat-header-cell *matHeaderCellDef>UUID</th>
          <td mat-cell *matCellDef="let row">{{row.uuid}}</td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
      </table>

    </mat-card-content>
    <mat-card-actions>
      <mat-paginator #paginator
        class="mat-paginator-sticky"
        (page)="getUpdate($event)"
        [pageIndex]="paginator.pageIndex"
        [length]="dataSource.length"
        [pageSizeOptions]="[10, 50, 100, 500]">
      </mat-paginator>
    </mat-card-actions>
  </mat-card>
</div>